/usr/bin/ltpmenu is in ltp 20091231+dfsg-1ubuntu2.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458 459 460 461 462 463 464 465 466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484 485 486 487 488 489 490 491 492 493 494 495 496 497 498 499 500 501 502 503 504 505 506 507 508 509 510 511 512 513 514 515 516 517 518 519 520 521 522 523 524 525 526 527 528 529 530 531 532 533 534 535 536 537 538 539 540 541 542 543 544 545 546 547 548 549 | #!/bin/sh
################################################################################
## ##
## Copyright (c) International Business Machines Corp., 2001 ##
## ##
## This program is free software; you can redistribute it and#or modify ##
## it under the terms of the GNU General Public License as published by ##
## the Free Software Foundation; either version 2 of the License, or ##
## (at your option) any later version. ##
## ##
## This program is distributed in the hope that it will be useful, but ##
## WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY ##
## or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License ##
## for more details. ##
## ##
## You should have received a copy of the GNU General Public License ##
## along with this program; if not, write to the Free Software ##
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA ##
## ##
################################################################################
#
# File: runltp
#
# Description: This program is a Graphical User Interface (GUI)
# Control Centre for LTP. The Control Centre provides
# functionality to Compile, Execute and View Results of
# LTP test cases.
#
# Author: Manoj Iyer - manjo@mail.utexas.edu
#
# Thanks: Jim Choate - For suggesting the use of dialog command.
#
# History: March 26 2003 - Created.
#
# March 28 2003 - Removed gauges and put make commands in foreground.
# Robbie Williamson - robbiew@us.ibm.com
#
# March 31 2003 - Made scenario menu creation dynamic and code
# to pull the test descriptions from the scenario files.
# Robbie Williamson - robbiew@us.ibm.com
#
# April 17 2003 - Added menu selection to list contents of selected
# scenario file.
# Robbie Williamson - robbiew@us.ibm.com
#
# April 23 2003 - Added PID to results filename.
# - Added code to allow users to redirect output and
# specify test execution duration.
# Robbie Williamson - robbiew@us.ibm.com
#
# April 30, 2003 - Recoded results display to allow selection
# of results file.
# - Created variable to hold results filename
# - Added time to results filename.
# Function: cleanup
#
# Description: Remove all temporary files created by this program. Cleanup
# always called on program exit.
#
# Input: NONE
#
# Output: NONE
cleanup()
{
rm -f $TMPDIR/runltp.*
}
# Function: display_info_msg
#
# Description: Displays informational messages window. This window may
# may be used to display information like errors, instructions
# etc to the user. The window is dismissed when the user hits
# the [ENTER] key.
#
# Input: $1 - Title the needs to be displayed on the window.
# eg: ERROR: Compiling LTP
# $2 - Message text.
#
# Output: Information message window.
display_info_msg()
{
dialog --backtitle "Linux Test Project Control Centre" \
--title " $1 " \
--msgbox " $2 " 10 70
return $?
}
# Function: compile_ltp
#
# Description: Checks for commands that are pre-reqs for compiling and
# installing LTP. It displays a confirmation window inorder to
# confirm the choice made by the user.
#
# Calls: do_make_clean()
# do_make()
# do_make_install()
#
# Input: NONE
#
# Output: Confirmation window.
compile_ltp()
{
dialog --backtitle "Linux Test Project Control Centre" \
--title "Compiling LTP testsuite"\
--yesno "This will compile all the test cases in\
LTP test suite and place the executables\
in testcases/bin directory. Do\
you wish to continue ??" 7 70 || RC=$?
case $RC in
0) \
for cmd in cc make lex ;
do \
which $cmd >$TMPDIR/runltp.err.$$ 2>&1;
if [ $? -ne 0 ] ;
then \
display_info_msg "Compiling LTP testsuite" \
"ERROR: command $cmd not found, $cmd is\
required to compile LTP test cases. Please\
install $cmd or export PATH correctly before\
running this program" ;
return ;
fi ;
done ;
make clean;
if [ $? -ne 0 ];then
echo "ERROR in \'make clean\' - exiting."
exit
fi
make ;
if [ $? -ne 0 ];then
echo "ERROR in \'make all\' - exiting."
exit
fi
make install ;
if [ $? -ne 0 ];then
echo "ERROR in \'make install\' - exiting."
exit
fi
return ;;
1) return ;;
255) return ;;
esac
}
# Function: disp_ltpres
#
# Description: The results generated after the ltp execution located under
# ltp-mmddyy/results/ directory in a text (ASCII) file called
# results.todaysdate. This function displays this file in a
# window. If the results file does not exit it displays an
# info message window notifing the user that LTP test cases
# need to be executed inorder to view results.
#
# Input: ltp-mmddyy/results/results.todaysdate.time
#
# Output: Window displaying results of testcases that were executed.
disp_ltpres()
{
RC=0
RESULTS_LIST=$(for i in `ls -1 -A -I "CVS" $LTPRESULTS`;do echo -n "$i [more...] "; done)
if ! [ -z $RESULTS_LIST ] ;then
while [ $RC -ne "1" ]
do
dialog --clear
dialog --backtitle "Linux Test Project Control Centre" \
--title "LTP Test Results" \
--menu "Move using[UP] [DOWN], Select using [ENTER]" 15 70 8 \
$RESULTS_LIST \
2>$TMPDIR/runltp.results.$$ || RC=$?
results_item=$(cat $TMPDIR/runltp.results.$$)
if ! [ -z $results_item ];then
dialog --clear
dialog --backtitle "Linux Test Project Control Centre" \
--title "LTP Test Results" \
--textbox $LTPRESULTS/$results_item 17 70
dialog --backtitle "Linux Test Project Control Centre" \
--title "LTP Test Results." \
--yesno "Would you like to share these results with the LTP \
community by posting it to the LTP results mailing list?" \
7 70 || RESPONSE=$?
case $RESPONSE in
0) \
mail ltp-results@lists.sourceforge.net < \
$LTPRESULTS/$results_item ;
;;
1) ;;
255) ;;
esac
fi
done
else
dialog --clear
dialog --backtitle "Linux Test Project Control Centre" \
--title "LTP Test Results" \
--msgbox "ERROR: No files to view in $LTPRESULTS directory." 5 53
fi
return
}
# Function: flags_prompt
#
# Description: Prompt for and record user options for run duration and
# test output direction
#
# Input: none
#
# Output: none
flags_prompt()
{
dialog --backtitle "Linux Test Project Control Centre"\
--title "Output Direction" --clear\
--yesno "Would you like test output recorded to a file, instead of STDOUT?" 7 80
RC=$?
if [ $RC -eq "0" ]
then
dialog --backtitle "Linux Test Project Control Centre"\
--title "Output Direction" --clear\
--inputbox " Please enter the full path and \
name of the file where you wish \
to redirect output to" 17 80 \
2>$TMPDIR/runltp.outdir.$$ ;
flags_outfile=$(cat $TMPDIR/runltp.outdir.$$ | awk '{print $1}')
$TOOLSDIR/ver_linux > $flags_outfile 2>&1
RUNALL_FLAGS=" -o $flags_outfile"
fi
dialog --backtitle "Linux Test Project Control Centre"\
--title "Test Duration" --clear\
--yesno "Would you like to specify test duration? \
Default is the length of one loop." 7 80
RC=$?
if [ $RC -eq "0" ]
then
dialog --backtitle "Linux Test Project Control Centre"\
--title "Test Duration - Interval Selection" --clear\
--menu "Move using[UP] [DOWN], Select using [ENTER]" 15 70 4 \
s "Seconds" \
m "Minutes" \
h "Hours" \
d "Days" \
2>$TMPDIR/runltp.interval.$$ ;
flags_interval=$(cat $TMPDIR/runltp.interval.$$ | awk '{print $1}')
case $flags_interval in
s) INTERVAL="seconds" ;;
m) INTERVAL="minutes" ;;
h) INTERVAL="hours" ;;
d) INTERVAL="days" ;;
esac
echo $INTERVAL
WINDOW_MSG="Please enter the number of $INTERVAL to run"
dialog --backtitle "Linux Test Project Control Centre"\
--title "Test Duration - Length Specification" --clear\
--inputbox "$WINDOW_MSG" 7 80 \
2>$TMPDIR/runltp.length.$$ ;
flags_length=$(cat $TMPDIR/runltp.length.$$ | awk '{print $1}')
flags_duration="$flags_length$flags_interval"
RUNALL_FLAGS=" $RUNALL_FLAGS -t $flags_duration"
fi
}
# Function: exectest_screenout
#
# Description: Execute tests by calling runltp, display test status
# in a window.
#
# Input: none
#
# Output: messages printed by testcases.
exectest_screenout()
{
RC=0 # setting return code to 0, to loop in while
RESULTS_FILE=$(date +%Y-%m-%d.%H.%M.%S).$$
# execute runltp with user defined command file.
$TOOLSDIR/runltp -q -p $RUNALL_FLAGS -l results.$RESULTS_FILE \
-f $TMPDIR/runltp.test.list.$$
sleep 2
return
}
# Function: execute_ltp
#
# Description: This function provides a menu of testcases that can be
# selected for execution. If networking tests are selected,
# they require a remote machine and remote machines root
# users password. The user will be prompted to enter this
# information in a text box.
# The function checks to see if the ltp-mmddyy/testcases/bin
# directory was created, this directory is created when the
# testcases are compiled and installed, if it is not found
# an info message window will notify the user that LTP needs to
# be compiled before tests can be executed.
# This function creates the senatrio file based on the users
# choice of testcases and uses the runltp script to
# execute these tests.
# The messages printed by the testcases are displayed on this
# terminal.
#
# Input: Users selection of testcases; scenario file.
#
# Output: Test selection window, Message window,
# information message window
execute_ltp()
{
RC=0
host_name=" "
rhost_passwd=" "
run_net_test=" "
# Pre-compiled in Debian
# if ! [ -d ./testcases/bin ]
# then
# display_info_msg "Executing LTP testcases" \
# "The testcases must to be compiled inorder\
# to execute them. Returning to main menu. \
# Please select the Compile option."
# return
# fi
LIST=$(for i in `ls -1 -A -I "CVS" $LTPROOT/runtest`; do echo -n "$i "; j=$(head -n1 $LTPROOT/runtest/$i | cut -d: -f2|sed s/" "/_/g); echo -n "$j off "; done)
dialog --backtitle "Linux Test Project Control Centre"\
--title "Execute LTP" --clear\
--checklist "Select [SPACEBAR] tests to run" 20 80 5 \
$LIST \
2>$TMPDIR/runltp.choice.$$ || RC=$?
size=`wc -m $TMPDIR/runltp.choice.$$|awk '{print $1}'`
if [ $size -eq 0 ];then
tst_choice=$(echo "NULL")
else
tst_choice=$(cat $TMPDIR/runltp.choice.$$)
fi
if [ $tst_choice = NULL ];then
RC=1
fi
case $RC in
0) \
for i in $tst_choice ;
do \
cat $LTPROOT/runtest/$(echo $i | sed -e 's/"//g') \
>> $TMPDIR/runltp.test.list.$$ ;
case "$(echo $i | sed -e 's/"//g')" in
"tcp_cmds" | "tcp_cmds_noexpect" |\
"multicast" | "nfs" |\
"ipv6_noexpect" | "ipv6")
run_net_test="Y"
esac
done ;
if ! [ -z $run_net_test ] ;
then \
dialog --backtitle "Linux Test Project Control Centre"\
--title "Execute LTP test cases" \
--clear \
--inputbox "You have chosen to execute testcases \
that require a Remote Machine. \
Please enter the fully qualified host \
name" 17 80 $(hostname --long) \
2>$TMPDIR/runltp.out.$$ ;
host_name=$(cat $TMPDIR/runltp.out.$$ | awk '{print $1}') ;
unset $RHOST ;
RHOST=$host_name ;
export RHOST;
dialog --backtitle "Linux Test Project Control Centre"\
--title "Execute LTP test cases" \
--clear \
--inputbox " Please enter the root password \
of this remote machine" 17 80 \
2>$TMPDIR/runltp.out.$$ ;
rhost_passwd=$(cat $TMPDIR/runltp.out.$$ | awk '{print $1}') ;
PASSWD=$rhost_passwd ;
export PASSWD;
fi ;
# Precompiled in Debian
# if ! [ -d ./testcases/bin ] ;
# then \
# display_info_msg "Executing LTP testcases" \
# "The testcases must to be compiled inorder\
# to execute them. Returning to main menu. \
# Please select the Compile option." ;
# return ;
# fi ;
dialog --clear ;
flags_prompt ;
exectest_screenout ;
return ;;
1) \
# echo "Cancel pressed" ;
return ;;
255) \
# echo "ESC pressed" ;
return ;;
esac
}
# Function: about_ltpcc
#
# Description: This function displays a window containing a brief message
# describing this programs functionality, and credits the author.
#
# Input: NONE
#
# Output: Message window, description of LTP Control Center.
about_ltpcc()
{
display_info_msg "About LTP Control Centre" \
"The LTP Control Centre can be used to\
to compile, install and execute\
The Linux Test Project test suite. Written by\
Manoj Iyer <manjo@mail.utexas.edu>"
return
}
# Function: ltp_scenarios
#
# Description: This function displays a list of scenario files located
# in $LTPROOT/runtest. Users can list the contents of each file.
#
# Input: Files from $LTPROOT/runtest
#
# Output: 1) Menu selection containing each file as an option to list.
# 2) Contents of selected scenario.
ltp_scenarios()
{
RC=0
SCENARIOS=$(for i in `ls -1 -A -I "CVS" $LTPROOT/runtest`;do echo -n "$i [more...] "; done)
while [ $RC -ne "1" ]
do
dialog --clear
dialog --backtitle "Linux Test Project Control Centre" \
--title "LTP Scenario Files" \
--menu "Move using[UP] [DOWN], Select using [ENTER]" 15 70 8 \
$SCENARIOS \
2>$TMPDIR/runltp.scenario.$$ || RC=$?
scenario_item=$(cat $TMPDIR/runltp.scenario.$$)
if ! [ -z $scenario_item ];then
dialog --clear
dialog --backtitle "Linux Test Project Control Centre" \
--title "LTP Scenario Files" \
--textbox $LTPROOT/runtest/$scenario_item 17 70
fi
done
}
# Function: main
#
# Description: Displays the main menu to the LTP Control Centre. The menu
# provides options to Compile, Execute, and View test execution
# results.
#
# Calls: about_ltpcc()
# compile_ltp()
# execute_ltp()
# disp_ltpres()
#
# Input: NONE
#
# Output: Menu selection of actions to perform.
# Global variables.
RC=0 # return code from commands and local functions
mmenu_item=" "
RHOST=" "
PASSWD=" "
RUNALL_FLAGS=" "
RESULTS_FILE=" "
TMPDIR=${TMPDIR:-/tmp}
LTPRESULTS=/var/cache/ltp/results
LTPROOT=/usr/lib/ltp/
TOOLSDIR=/usr/lib/ltp/tools
# test for dialog program exist
if [ ! -x /usr/bin/dialog ]; then
echo "Sorry, ltpmenu GUI not available, can't find dialog. Exiting...";
exit 1;
fi
# call cleanup function on program exit.
trap "cleanup" 0
# wait in a loop until user hits [Cancel] button on the main menu.
while :
do
RC=0
dialog --clear
dialog --backtitle "Linux Test Project Control Centre" \
--title "Main Menu" \
--menu "Move using[UP] [DOWN], Select using [ENTER]" 15 70 5 \
About "About LTP Control Centre" \
Details "Details of scenario files" \
Execute "Execute LTP testsuite" \
Results "Display a summary of test results" \
2>${TMPDIR:-/tmp}/runltp.mainmenu.$$ || RC=$?
case $RC in
0) mmenu_item=`cat /tmp/runltp.mainmenu.$$` ;
# echo "return code = $RC" ;
# echo "MENU ITEM = $mmenu_item" ;
case $mmenu_item in
About) about_ltpcc ;;
# Compile) compile_ltp ;;
Details) ltp_scenarios ;;
Execute) execute_ltp ;;
Results) disp_ltpres ;;
esac ;;
1) display_info_msg "Good Bye!" \
"Thank you for using Linux Test Project test suite.\
Please visit our project website \
http://ltp.sourceforge.net \
for latest news on The Linux Test Project. "
exit ;;
255) display_info_msg "Good Bye!" \
"Thank you for using Linux Test Project test suite.\
Please visit our project website\
http://ltp.sourceforge.net for latest news\
on The Linux Test Project. "
exit;;
esac
done
|